module KoL.Network where

import Prelude hiding (read, catch)

import KoL.Http
import KoL.Util
import qualified Data.ByteString.Char8

postLoginPage uri params cu = do
	let (_cookie, useragent, host) = cu
	putStrLn $ "posting login!"
	(text, effuri, headers) <- internalKolRequest uri (Just params) (Nothing, useragent, host, Nothing) False
	let addheaders = filter (\(x, _y) -> (x == "Set-Cookie" || x == "Location")) headers
	return (text, effuri, addheaders)

postHttpsLoginPage uri params cu = do
	let (_cookie, useragent, host) = cu
	putStrLn $ "posting https login!"
	(text, effuri, headers) <- internalKolHttpsRequest uri (Just params) (Nothing, useragent, host, Nothing) False
	putStrLn $ "response: " ++ show effuri ++ " | " ++ show headers
	putStrLn $ "response: " ++ (Data.ByteString.Char8.unpack text)
	let addheaders = filter (\(x, _y) -> (x == "Set-Cookie" || x == "Location")) headers
	return (text, effuri, addheaders)

login (useragent, host) user pass = do
	(text, _effuri, _headers) <- internalKolRequest (mkuri "/") Nothing (Nothing, useragent, host, Nothing) False
	let [[challenge]] = matchGroups "<input type=hidden name=challenge value=\"([0-9a-f]*)\">" (Data.ByteString.Char8.unpack text)
	let response = get_md5 (pass ++ ":" ++ challenge)
	(_text, _effuri, headers) <- internalKolRequest (mkuri "/login.php") (Just [("loginname", user), ("challenge", challenge), ("response", response), ("secure", "1"), ("loggingin", "Yup.")]) (Nothing, useragent, host, Nothing) True
	putStrLn $ "Logged in " ++ user ++ "..."
	let cookie = lookup "Set-Cookie" headers
	return cookie
