import KoL.Util
import State
import Data.Maybe
import qualified Data.Map
import Control.Exception
import Data.List
import System
import System.Directory
import System.Posix.Files

print_data x y = do
	let as_strstr = read_as y :: Maybe [(String, String)]
	let as_intstr = read_as y :: Maybe [(Integer, String)]
-- 	putStrLn $ x ++ " = " ++ y
	case (as_strstr, as_intstr) of
		(Just z, _) -> do
			putStrLn $ x ++ " (" ++ (show $ length z) ++ "):"
			mapM_ (\(x,y) -> putStrLn $ "  " ++ x ++ " = " ++ y) z
		(Nothing, Just z) -> do
			putStrLn $ x ++ " (" ++ (show $ length z) ++ "):"
			mapM_ (\(x,y) -> putStrLn $ "  " ++ (show x) ++ ":" ++ y ++ ",") z
		otherwise -> do
			putStrLn $ x ++ ":?: " ++ y
	return ()

print_map title mapdata = do
	putStrLn $ "== " ++ title ++ " =="
	mapM_ (\(x,y) -> print_data x y) (Data.Map.toList mapdata)

main = do
	args <- getArgs
	basedir <- getBaseDirectory "state"
	cookiefile <- case args of
		[cf] -> return cf
		otherwise -> do
			filenames <- getDirectoryContents basedir
-- 			putStrLn $ "filenames: " ++ (show filenames)
			let print_status fn = do
				fs <- getFileStatus (basedir ++ fn)
				let modtime = modificationTime fs
				return (modtime, fn)
			things <- mapM print_status $ filter (\x -> isPrefixOf "session-" x) filenames
			return $ snd $ last $ sort things
	cookiemap <- readMapFromFile cookiefile
	print_map "session" cookiemap
	let charname = fromJust $ Data.Map.lookup "character" cookiemap
	let ascnum = read $ fromJust $ Data.Map.lookup "ascension number" cookiemap :: Integer
	let day = read $ fromJust $ Data.Map.lookup "day" cookiemap :: Integer
	charmap <- readMapFromFile ("char-" ++ charname ++ ".state")
	ascmap <- readMapFromFile ("ascension-" ++ charname ++ "-" ++ (show ascnum) ++ ".state")
	daymap <- readMapFromFile ("day-" ++ charname ++ "-" ++ (show ascnum) ++ "-" ++ (show day) ++ ".state")
	print_map "character" charmap
	print_map "ascension" ascmap
	print_map "day" $ Data.Map.filterWithKey (\x y -> not $ isPrefixOf "fight." x) daymap
	print_map "fight" $ Data.Map.filterWithKey (\x y -> isPrefixOf "fight." x) daymap
	return ()
